#define NWDOS
#include <stdio.h>
#include <string.h>
#include <nwcalls.h>
#include <nwdsdc.h>
#include <nwlocale.h>
#include <nwnet.h>

extern unsigned _stklen = 8000;

void main (int argc, char *argv[])
{
	char far *countryPtr;
	LCONV lconvInfo;
	NWDSCCODE ccode;
	NWCONN_HANDLE connList[20], conn;
	NWNUMBER	numConns;
	NWDSContextHandle defContext;
	int i;
	char server[100];
	char user[256];
	char password[50];
	char newTree[50];
	char newContext[256];

	if (argc != 5)
	{
		printf ("Usage:  CHNGTREE newTreeName newContext userName password\n");
		return;
	}

	strcpy (newTree, argv[1]);
	strcpy (newContext, argv[2]);
	strcpy (user, argv[3]);
	strcpy (password, argv[4]);

  ccode = NWCallsInit (NULL,NULL);
	if (ccode)
  {
    printf ("NWCallsInit returned %X\n", ccode);
    return;
  }

	countryPtr = NWLsetlocale (LC_ALL,"");
	NWLlocaleconv (&lconvInfo);

	if ((ccode = NWInitUnicodeTables (lconvInfo.country_id,
		lconvInfo.code_page)) != 0)
	{
		printf ("NWInitUnicodeTables returned %04X\n", ccode);
		return;
	}

	defContext = NWDSCreateContext ();

	ccode = NWDSLogout (defContext);
	if (ccode)
	{
    printf ("NWDSLogout returned %X\n", ccode);
//		NWFreeUnicodeTables ();
//		return;
	}

	ccode = NWGetConnectionList (0, connList, 20, &numConns);
	if (ccode)
	{
		printf ("NWGetConnectionList returned %X\n", ccode);
		NWFreeUnicodeTables ();
		return;
	}

  // Only need to clear NDS connections, but I'm clearing all for simplicity

	for (i = 0; i < numConns; i++)
	{
		ccode = NWGetFileServerName (connList[i], server);
		if (ccode)
		{
			printf ("NWGetFileServerName returned %X\n", ccode);
		}
		else
		{
			printf ("Detaching from %s\n", server);
		}

		ccode = NWDetachFromFileServer (connList[i]);
		if (ccode)
		{
			printf ("NWDetachFromFileServer returned %X\n", ccode);
		}
		NWFreeConnectionSlot (connList[i], SYSTEM_DISCONNECT);
	}

	ccode = NWSetPreferredDSTree (strlen (argv[1]), argv[1]);
	if (ccode)
	{
		printf ("NWSetPreferredDSTree returned %X\n", ccode);
		NWFreeUnicodeTables ();
		return;
	}

	ccode = NWGetPreferredDSServer (&conn);
	if (ccode)
	{
		printf ("NWGetPreferredDSServer returned %X\n", ccode);
		NWFreeUnicodeTables ();
		return;
	}

	ccode = NWSetDefaultNameContext (strlen (argv[2]), argv[2]);
	if (ccode)
	{
		printf ("NWSetDefaultNameContext returned %X\n", ccode);
		NWFreeUnicodeTables ();
		return;
	}

  ccode = NWGetDefaultConnectionID (&conn);
  if (ccode)
  {
    printf ("NWGetDefaultConnectionID returned %X\n", ccode);
  }

	printf ("Tree is %s, context is %s\n", argv[1], argv[2]);

	NWFreeUnicodeTables ();
}